.TH SGMPXPERFMON LOCAL "November 1 1987"
.SH NAME
sgmpxperfmon - graphical SGMP performance monitor
.SH SYNOPSIS
.B sgmpxperfmon gw [qualifiers] [options]
.SH DESCRIPTION
.LP
.I sgmpxperfmon 
is a graphical performance monitor modeled after
.I xperfmon(1).
It is compatible with Release 4 of X-Windows version 10.
Unlike
.I xperfmon
however,
.I sgmpxperfmon
monitors net interfaces instead of systems. Specifically,
.I sgmpxperfmon
monitors any or all of the input and output byte and packet counts on any
or all net interfaces on a gateway.
.I gw,
the gateway to be monitored is specified as a dot notation address such
as '128.213.1.2'.
.SH QUALIFIERS
.LP
The
.I qualifiers
specified on a command line allows the user to restrict monitoring to a subset
of the possible information. Valid qualifiers are:
.sp
.IP -
.I input:
monitor only input information.
.IP -
.I output:
monitor only output information.
.I bytes:
monitor only byte counts.
.IP -
.I packets:
monitor only packet counts.
.LP
Note that these qualifiers may be combined, so that, for example, specifying
.I input bytes
on the command line will result in
.I sgmpxperfmon
monitoring only the count of bytes coming into the net interfaces on a gateway.
.SH OPTIONS
.LP
Possible options that may be specified on the command line are:
.sp
.IP -
.I -s session:
set the name of the session for queries to
.I session.
If this option is not used, the session name defaults to 'public'.
.IP -
.I host:display :
use the display
.I display
on host
.I host
to display information.
.IP -
.I geometry:
set the geometry of the window to
.I geometry.
.IP -
.IP -
.I -rv:
toggle reverse video.
.IP -
.I -bw width:
set the width of the display window's border to 
.I width.
.IP -
.I -fn font:
set the font used to
.I font.
.IP -
.I -bd color:
set the display color to
.I color.
.IP -
.I -fg foreground:
set the foreground color to
.I foreground.
.IP -
.I -bg background:
set the background color to 
.I background
.IP -
.I -hl highlight:
set the highlight color to 
.I highlight
.IP -
.I  -u update:
update the display every
.I update
seconds. 
.IP -
.I -in# address:
monitor only the net interface with IP address
.I address.
.SH FILES
.in +5
/etc/sgmp.variables        default variable initfile
.br
/etc/services              to find the 'sgmp' service
.in -5
.SH SEE ALSO
sgmpask(l),sgmplookup(l),sgmpquery(l),sgmpwatch(l),"A Simple Gateway Monitoring
Protocol", RFC 1028, by J.R. Davin, J.D Case, M.S. Fedor, M.L. Schoffstall
